﻿using Infragistics;
using Infragistics.Controls;
using Infragistics.Controls.Charts;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Diagnostics;
using System.Linq;
using System.Windows;

namespace DrawingApp
{ 
    public partial class DiagramWindow : Window
    {
        public DiagramWindow()
        {
            InitializeComponent();
            
            this.DiagramPlot.PropertyChanged += DiagramPlot_PropertyChanged;
              
            DiagramPlot.MouseRightButtonDown += DiagramPlot_MouseRightButtonDown;

            this.Loaded += (s, e) => DiagramPlot.ScaleToFit(); 
        }

        private void DiagramPlot_MouseRightButtonDown(object sender, System.Windows.Input.MouseButtonEventArgs e)
        {
            var pos = e.GetPosition(this.DiagramPlot);

            Debug.WriteLine("Diagram_MouseRightButtonDown " +
                   " GetPosition " + pos +
                   " ViewportToWorld " + this.DiagramPlot.ViewportToWorld(pos) +
                   " WorldToViewport " + this.DiagramPlot.WorldToViewport(pos)  );
        }
         

        private void DiagramPlot_PropertyChanged(object sender, PropertyChangedEventArgs e)
        {
            // synconize WindowRect of XamDiagramPlot with WindowRect of XamDataChart
            if (e.PropertyName == "WindowRect")
            {
                //var max = DiagramPlot.MaximumZoomLevel;
                //var min = DiagramPlot.MinimumZoomLevel;

                //var zoom = DiagramPlot.ZoomLevel;
                //var zoom2 = DiagramPlot.ZoomLevelDisplayText;

                //if (double.IsNaN(DiagramPlot.MinimumZoomLevel))
                //{
                //    DiagramPlot.MinimumZoomLevel = 0.1;
                //}

                //var zoomFactor = DiagramPlot.MinimumZoomLevel;  //double.IsNaN(DiagramPlot.MinimumZoomLevel) ? 0.1 : DiagramPlot.MinimumZoomLevel;

                //// convert XamDiagramPlot coordinates to XamDataChart coordinates
                //var x = this.DiagramPlot.WindowRect.X / this.DiagramPlot.ViewportRect.Width * zoomFactor;
                //var y = this.DiagramPlot.WindowRect.Y / this.DiagramPlot.ViewportRect.Height * zoomFactor;

                //var w = this.DiagramPlot.WindowRect.Width / this.DiagramPlot.ViewportRect.Width * zoomFactor;
                //var h = this.DiagramPlot.WindowRect.Height / this.DiagramPlot.ViewportRect.Height * zoomFactor;

                //if (x < 0)
                //{
                //    w -= x; x = 0;
                //}
                //if (y < 0)
                //{
                //    h -= y; y = 0;
                //}

                //var winRect = new Rect(x, y, w, h);

                //Debug.WriteLine("DiagramPlot_PropertyChanged " + e.PropertyName +
                //    " ViewportRect " + this.DiagramPlot.ViewportRect +
                //    " ZoomLevel " + DiagramPlot.ZoomLevel + 
                //    " WindowRect " + this.DiagramPlot.WindowRect +
                //   // " WindowRectC " + winRect +
                //    " WorldRect " + this.DiagramPlot.WorldRect); 
            } 
        }
               
        private void ToolsRadioButton_Checked(object sender, RoutedEventArgs e)
        {
            if (this.DiagramPlot != null)
            {
                if (sender.ToString() == "Pointer")
                {
                    this.DiagramPlot.Tool = DiagramTool.Pointer;
                }
                else
                {
                    this.DiagramPlot.Tool = DiagramTool.Connector;
                }
            }
        }

        private void ConnectionsDisplayModeRadioButton_Checked(object sender, RoutedEventArgs e)
        {
            if (this.DiagramPlot != null)
            {
                if (sender.ToString() == "Always")
                {
                    this.DiagramPlot.ConnectionPointsDisplayMode = DiagramConnectionPointsDisplayMode.Always;
                }
                else if (sender.ToString() == "Auto")
                {
                    this.DiagramPlot.ConnectionPointsDisplayMode = DiagramConnectionPointsDisplayMode.Auto;
                }
                else if (sender.ToString() == "MouseOver")
                {
                    this.DiagramPlot.ConnectionPointsDisplayMode = DiagramConnectionPointsDisplayMode.MouseOver;
                }
                else if (sender.ToString() == "Never")
                {
                    this.DiagramPlot.ConnectionPointsDisplayMode = DiagramConnectionPointsDisplayMode.Never;
                }
            }
        }

        private void DragInteractionRadioButton_Checked(object sender, RoutedEventArgs e)
        {
            if (this.DiagramPlot != null)
            {
                if (sender.ToString() == "None")
                {
                    this.DiagramPlot.DefaultDragInteraction = DiagramDragInteraction.None;
                }
                else if (sender.ToString() == "Pan")
                {
                    this.DiagramPlot.DefaultDragInteraction = DiagramDragInteraction.Pan;
                }
                else if (sender.ToString() == "Select")
                {
                    this.DiagramPlot.DefaultDragInteraction = DiagramDragInteraction.Select;
                }
                else if (sender.ToString() == "Zoom")
                {
                    this.DiagramPlot.DefaultDragInteraction = DiagramDragInteraction.Zoom;
                }
            }
        }

    }
}
